
# function to get bootstrapped matrices --------------------------------------------------
#install.packages("openxlsx")
library("openxlsx")

cnt_matrix<-function(data_p,data_c, pop.file, pop.sheet){ 
  # data_p is the participants database, 
  # data_c is the contacts database, 
  # pop.file is the file with the population size under different age groups
  # pop.sheet is the sheet  in the pop.file, the second one is for Shanghai, first one is for Wuhan
  
  p<-data_p
  c<-data_c
  
  w<-read.xlsx(pop.file,sheet = pop.sheet,colNames=T)
  pop<-w$freq/sum(w$freq)
  n<-round(length(p$subid)*pop)
  ag<-levels(p$age_group5)
  
  
  bs<-list()
  
  for(j in 1:100){
    s.p<-c()
    s.c<-c()
    
    for(k in 1:length(ag)){
      for(i in 1:n[k]){
        id<-sample(p[age_group5 %in% ag[k]]$subid,1)
        a<-p[subid %in% id];b<-c[subid%in%id]
        a$part_id<-paste0(a$subid,i);b$part_id<-paste0(b$subid,i)
        s.p<-rbind(s.p,a);s.c<-rbind(s.c,b)
      }
    }
    
    
    s.p$part_id<-as.numeric(s.p$part_id);s.c$part_id<-as.numeric(s.c$part_id)
    s.c$cnt_age_exact<-as.numeric(as.character(s.c$cnt_age_exact))
    s.c$cnt_age_est_min<-as.numeric(as.character(s.c$cnt_age_est_min))
    s.c$cnt_age_est_max<-as.numeric(as.character(s.c$cnt_age_est_max))
    
    for(i in 1:nrow(s.c)){
      if(is.na(s.c$cnt_age_exact[i]) & !is.na(s.c$cnt_age_est_min[i]) & !is.na(s.c$cnt_age_est_max[i])) s.c$cnt_age_exact[i]<-sample(round(s.c$cnt_age_est_min[i]):round(s.c$cnt_age_est_max[i]),1)
    }
    
    survey_sh<-survey(s.p,s.c)
    lower.age.limit<-c(0,5,10,15,20,25,30,35,40,45,50,55,60,65)
    m<-contact_matrix(survey_sh,age.limits = lower.age.limit,symmetric=F,missing.contact.age="sample",n=1)
    a<-m$matrix
    for(h in 1:14){
      for(u in 1:14){
        if(is.na(a[h,u])) a[h,u]<-0
      }
    }
    bs[[j]]<-a
    
  }
  
  return(bs)
  
}

#install.packages("socialmixr")
library(socialmixr)
#install.packages("data.table")
library(data.table)

# For example, to get Shanghai outbreak matrix---------------------------------------------------

sh2.all <- read.csv("Participant_Shanghai.csv")
participants<-sh2.all[,c("part_id","part_age")] #participant database
colnames(participants)[1]<-c("subid")
participants$country<-"China"
participants$age_group5<-cut(participants$part_age,c(seq(0,65,5),100),right=F)
participants<-as.data.table(participants)

sh2.cnt.detail <- read.csv("Contacts_Shanghai_outbreak.csv")
contacts<-sh2.cnt.detail[,c("part_id","cnt_age_exact","cnt_age_est_min","cnt_age_est_max")] # contact database
colnames(contacts)[1]<-c("subid")
contacts<-as.data.table(contacts)

bs<-cnt_matrix(data_p=participants,data_c=contacts,
               pop.sheet=2, pop.file = "WH_SH_pop.xlsx") # 100 bootstrapped matrices
matrix_sh2 <- Reduce("+", lapply(bs, function(x) {x})) / length(bs) # mean bootstrapped matrix

